#!/bin/sh

extension="tournesol_lc";

Fh=0.1;

#############
# b=15.

b=15.;
facteur=1.

sed -e 's#base2d_init=\"\".*#base2d_init=\"/toon/usr/deloncle/linear_stability_vortex_arrays/von_karman_kappa_0.2/Ro_inf/ns3d_karman_kappa_0.2_a_1_256x640x1_L=15.x38.x1.09_Dt=0.01_nu=2.E-5_N=10._zahir_07-06-07_19h05_pid11575/base2D.init\"#' \
	-e "s/#define DIMX .*/#define DIMX 256/" \
    -e "s/lx___________________________   .*/lx___________________________   15./" \
    -e "s/itmax________________________ .*/itmax________________________   120000/" \
    job_large_core_tournesol.sh > job_${extension}.sh

sed 's#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/.*#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/Ro_inf\"#' job_${extension}.sh > job_${extension}_bis.sh

for bkzFh in 14
do
  if [ $bkzFh = 0 ]; then
    kz=0. ;
	lz=0. ;
  else
	kz=`echo "scale=8; ($bkzFh*$facteur)/($b*$Fh)" | bc` ;
    lz=`echo "scale=2; 2*3.1416/$kz" | bc` ;
  fi

  echo $bkzFh $facteur $kz $lz ;

  sed "s/lz___________________________   .*/lz___________________________   $lz/" job_${extension}_bis.sh > job_${extension}.sh
  chmod 744 *
  ./job_${extension}.sh	
done


#############
# b=7.5

b=7.5;
facteur=1.

sed -e 's#base2d_init=\"\".*#base2d_init=\"/toon/usr/deloncle/linear_stability_vortex_arrays/von_karman_kappa_0.2/large_core/base_state/ns3d_karman_large_core_128x640x1_L=7.5x38.x1._Dt=0.01_nu=2.E-5_N=0_28-09-07_15h43/base2D_128x640_L=7.5x38_be\"#' \
	-e "s/#define DIMX .*/#define DIMX 128/" \
    -e "s/lx___________________________   .*/lx___________________________   7.5/" \
    job_large_core_tournesol.sh > job_${extension}.sh

sed 's#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/.*#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/large_core/karman_large_core_b_7.5\"#' job_${extension}.sh > job_${extension}_bis.sh

for bkzFh in 20 22
do
  if [ $bkzFh = 0 ]; then
    kz=0. ;
	lz=0. ;
  else
	kz=`echo "scale=8; ($bkzFh*$facteur)/($b*$Fh)" | bc` ;
    lz=`echo "scale=2; 2*3.1416/$kz" | bc` ;
  fi

  echo $bkzFh $facteur $kz $lz ;

  sed "s/lz___________________________   .*/lz___________________________   $lz/" job_${extension}_bis.sh > job_${extension}.sh
  chmod 744 *
  ./job_${extension}.sh	
done


#############
# b=10

b=10.;
facteur=1.

sed -e 's#base2d_init=\"\".*#base2d_init=\"/toon/usr/deloncle/linear_stability_vortex_arrays/von_karman_kappa_0.2/large_core/base_state/ns3d_karman_large_core_192x1024x1_L=10.x38.x1._Dt=0.01_nu=2.E-5_N=0_27-09-07_19h49/base2D_192x640_L=10x38_be\"#' \
	-e "s/#define DIMX .*/#define DIMX 192/" \
    -e "s/lx___________________________   .*/lx___________________________   10./" \
    job_large_core_tournesol.sh > job_${extension}.sh

sed 's#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/.*#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/large_core/karman_large_core_b_10\"#' job_${extension}.sh > job_${extension}_bis.sh

for bkzFh in 17.4 19
do
  if [ $bkzFh = 0 ]; then
    kz=0. ;
	lz=0. ;
  else
	kz=`echo "scale=8; ($bkzFh*$facteur)/($b*$Fh)" | bc` ;
    lz=`echo "scale=2; 2*3.1416/$kz" | bc` ;
  fi

  echo $bkzFh $facteur $kz $lz ;

  sed "s/lz___________________________   .*/lz___________________________   $lz/" job_${extension}_bis.sh > job_${extension}.sh
  chmod 744 *
  ./job_${extension}.sh	
done


#############
# b=5

b=5.;
facteur=1.

sed -e 's#base2d_init=\"\".*#base2d_init=\"/toon/usr/deloncle/linear_stability_vortex_arrays/von_karman_kappa_0.2/large_core/base_state/ns3d_karman_large_core_96x1024x1_L=5.x38.x1._Dt=0.01_nu=2.E-5_N=0_27-09-07_19h42/base2D_96x640_L=5x38_be\"#' \
	-e "s/#define DIMX .*/#define DIMX 96/" \
    -e "s/lx___________________________   .*/lx___________________________   5./" \
    job_large_core_tournesol.sh > job_${extension}.sh

sed 's#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/.*#dir_save_tournesol=\"/home/deloncle/von_karman_kappa_0.2/large_core/karman_large_core_b_5\"#' job_${extension}.sh > job_${extension}_bis.sh

for bkzFh in 24
do
  if [ $bkzFh = 0 ]; then
    kz=0. ;
	lz=0. ;
  else
	kz=`echo "scale=8; ($bkzFh*$facteur)/($b*$Fh)" | bc` ;
    lz=`echo "scale=2; 2*3.1416/$kz" | bc` ;
  fi

  echo $bkzFh $facteur $kz $lz ;

  sed "s/lz___________________________   .*/lz___________________________   $lz/" job_${extension}_bis.sh > job_${extension}.sh
  chmod 744 *
  ./job_${extension}.sh	
done
