% ######################
% global_vars a renseigner
% ######################

% ######################
% on touche plus
% ######################

if strcmp('PCWIN', computer)
	system('dir /O-D /AD /B .');
else
	system('ls -t .');
end

nom_fichier = input('\nFichier d etat de base a representer: ', 's');


% on determine le type de codage (little-endian, big-endian) en regardant l'en-tete du fichier

% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(nom_fichier, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(nom_fichier, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end


% on lit toutes les metadonnees
FID = fopen(nom_fichier, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub = fread(FID, 1, 'integer*4');
VBX = fread(FID, nx*ny, 'real*8');
VBY = fread(FID, nx*ny, 'real*8');
VBZ = fread(FID, nx*ny, 'real*8');
poub = fread(FID, 2, 'integer*4');
WBX = fread(FID, nx*ny, 'real*8');
WBY = fread(FID, nx*ny, 'real*8');
WBZ = fread(FID, nx*ny, 'real*8');
status = fclose(FID);

% on reordonne les tableaux
VBX = reshape(VBX, [nx,ny]);
VBY = reshape(VBY, [nx,ny]);
VBZ = reshape(VBZ, [nx,ny]);
WBX = reshape(WBX, [nx,ny]);
WBY = reshape(WBY, [nx,ny]);
WBZ = reshape(WBZ, [nx,ny]);


% on affiche quelques informations sur la simulation
fprintf(1, '\n Dimensions du probleme: %i * %i * %i \n', nx, ny);
fprintf(1, '\n Dimensions physiques de la boite: %f * %f * %f \n\n', lx, ly);

%% We display the final base state
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);

figure(1)
pcolor(X,Y,WBZ');
axis equal tight   
shading interp
lighting phong
colorbar
xlabel('x');
ylabel('y');
title('Vorticite verticale base state');
