% On choisit si on utilise dans les differents graphiques
%   1) la fonction contour. Trace plus joli mais plus long.
%   2) la fonction pcolor. Trac rapide en particulier s'il n'y a pas de structure mais grossier
type_graphique = 2;

% field to plot (vx=1,vy=2,vz=3,rho=4,wx=5,wy=6,wz=7)
type_field=5;

% ######################
% on touche plus
% ######################

if strcmp('PCWIN', computer)
	system('dir /O-D /AD /B .');
else
	system('ls -t .');
end

name_file = input('\nFichier de vitesse a representer: ', 's');


% On determine si les fichiers sont ecrits en little-endian ou en big-endian

% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(name_file, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(name_file, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end


% on lit toutes les metadonnees
FID = fopen(name_file, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
dt              = fread(FID, 1, 'real*8');
truncate        = fread(FID, 1, 'integer*4');
type_trunc      = fread(FID, 1, 'integer*4');
rtrunc_x        = fread(FID, 1, 'real*8');
rtrunc_y        = fread(FID, 1, 'real*8');
rtrunc_z        = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
stratification  = fread(FID, 1, 'integer*4');
xns             = fread(FID, 1, 'real*8');
schm            = fread(FID, 1, 'real*8');
omega2          = fread(FID, 1, 'real*8');
perturb         = fread(FID, 1, 'integer*4');
lin             = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
instant         = fread(FID, 1, 'real*8');
status = fclose(FID);


% on affiche quelques informations sur la simulation
fprintf(1, '\n Dimensions du probleme: %i * %i * %i \n', nx, ny, nz);
fprintf(1, '\n Dimensions physiques de la boite: %f * %f * %f \n', lx, ly, lz);

if (stratification == 0)
    freq_brunt = 0;
else
    freq_brunt = xns;
end

fprintf(1, '\n Stratification: %f \n', freq_brunt);

if (perturb==0)
    texte = ['non perturbatif'];
else
    if (lin==0) then
        texte = ['perturbatif/non lineaire'];
    else
        texte = ['perturbatif/lineaire'];
    end
end


% on cre la grille des points de colocation
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);

% on demande quel plan representer
iz = floor(input('\nPlan de coupe: '));

% on lit les donnees correspondant au plan choisi
FID = fopen(name_file, 'r',type_endian);
type_field = 5;
iz=1
fseek(FID,33*4 + (4+8+4) + (type_field-1)*(4+8*nx*ny*nz+4) + 4 + 8*(iz-1)*nx*ny, 'bof');
Vort_X = fread(FID, nx*ny*nz, 'real*8');
status = fclose(FID);
Vort_X = reshape(Vort_X, [nx,ny,nz]);

FID = fopen(name_file, 'r',type_endian);
type_field = 6;
iz=1
fseek(FID,33*4 + (4+8+4) + (type_field-1)*(4+8*nx*ny*nz+4) + 4 + 8*(iz-1)*nx*ny, 'bof');
Vort_Y = fread(FID, nx*ny*nz, 'real*8');
status = fclose(FID);
Vort_Y = reshape(Vort_Y, [nx,ny,nz]);

Vort_h = sqrt(Vort_X.^2 + Vort_Y.^2);


figure(30)
fprintf(1, '      Plotting...\n');
pmoy_v=mean(max(max(Vort_h)));
nmoy_v=-pmoy_v;

p = patch(isosurface(Y,X,Z,Vort_h,0.6*pmoy_v));
isonormals(Y,X,Z,Vort_h,p)
set(p,'FaceAlpha',0.9,'FaceColor','red','EdgeColor','none');
p2 = patch(isosurface(Y,X,Z,Vort_h,0.1*pmoy_v));
isonormals(Y,X,Z,Vort_h,p2)
set(p2,'FaceAlpha',0.15,'FaceColor',[255,251,140]/256,'EdgeColor','none');

p3 = patch(isosurface(Y,X,Z,Vort_h,0.6*nmoy_v));
isonormals(Y,X,Z,Vort_h,p3)
set(p3,'FaceAlpha',0.9,'FaceColor','blue','EdgeColor','none');
p4 = patch(isosurface(Y,X,Z,Vort_h,0.1*nmoy_v));
isonormals(Y,X,Z,Vort_h,p4)
set(p4,'FaceAlpha',0.15,'FaceColor',[130,186,212]/256,'EdgeColor','none');

daspect([1 1 1])
view(3);
axis([Y(1) Y(end) X(1) X(end) Z(1) Z(end)])
box on
grid on
camlight
lighting gouraud
