# we indicate where the velocity files are stores on gaya
dir_save="/toon/usr/deloncle/temp_post_traitement/ns3d_contrarotating_amp=-0.026_512x512x64_L=4.2x4.2x0.57_Dt=0.005_nu=0.0003_N=12._brodie_22-05-07_15h20"

# dimensions of the velocity files and the strides along each directions
nx=512
ny=512
nz=64
str_x=2
str_y=2
str_z=1

#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nATTENTION SCRIPT BUGGUE SUR PC\n"

printf "\nTemp directory: $dir_save\n"

cp io_stride.F90 $dir_save
cd $dir_save

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    -e "s/integer, parameter :: str_x=.*/integer, parameter :: str_x=$str_x/" \
    -e "s/integer, parameter :: str_y=.*/integer, parameter :: str_y=$str_y/" \
    -e "s/integer, parameter :: str_z=.*/integer, parameter :: str_z=$str_z/" \
    io_stride.F90 > io_stride.F90_bis

mv io_stride.F90_bis io_stride.F90

# compilation
printf "\nCompilation of the Fortran code...\n"
ifort -O3 io_stride.F90 -o io_stride -convert big_endian
chmod 744 io_stride

# useful to store the strided files on Gaya
nxp=`expr $nx - 1`
nxp=`expr $nxp / $str_x + 1`
nyp=`expr $ny - 1`
nyp=`expr $nyp / $str_y + 1`
nzp=`expr $nz - 1`
nzp=`expr $nzp / $str_z + 1`

# we get the list of the original velocity files
printf "\nGetting the list of the original files...\n"
ls -1 velo_rho* > liste_fichiers.txt

# Copy of each file...
printf "\nCopy of each file...\n"
mkdir stride_${nxp}x${nyp}x${nzp}
for name in `cat liste_fichiers.txt`; do
	printf "\n    velocity file: $name";
	echo $name | ./io_stride;
    mv stride_$name stride_${nxp}x${nyp}x${nzp}/$name;
done

exit
