% Ce script permet de convertir un fichier de sortie de ns3d (velo_rho_vort_t=****.***
% de little-endian en big-endian ou inversement.


% ######################
% global_vars a renseigner
% ######################


% dossier de depart dans lequel on va regarder...
dirbase ='.';


% ######################
% on touche plus
% ######################

fprintf(1, '\n dossier de base: \n %s \n', dirbase);

if strcmp('PCWIN', computer)
	ls(dirbase);
else
	system(['ls -t ', dirbase]);
end

dir = input('dossier specifique: ', 's');
dirt = [dirbase,'/',dir]


if strcmp('PCWIN', computer)
	ls(dirt);
else
	system(['ls -tl ', dirt]);
end

fichier = input('fichier de vitesse specifique: ', 's');



% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen([dirt,'/',fichier], 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen([dirt,'/',fichier], 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end


% on lit toutes les metadonnees
FID = fopen([dirt,'/',fichier], 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
NX              = fread(FID, 1, 'integer*4');
NY              = fread(FID, 1, 'integer*4');
NZ              = fread(FID, 1, 'integer*4');
LX              = fread(FID, 1, 'real*8');
LY              = fread(FID, 1, 'real*8');
LZ              = fread(FID, 1, 'real*8');
dt              = fread(FID, 1, 'real*8');
truncate        = fread(FID, 1, 'integer*4');
type_trunc      = fread(FID, 1, 'integer*4');
rtrunc_x        = fread(FID, 1, 'real*8');
rtrunc_y        = fread(FID, 1, 'real*8');
rtrunc_z        = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
stratification  = fread(FID, 1, 'integer*4');
xns             = fread(FID, 1, 'real*8');
schm            = fread(FID, 1, 'real*8');
omega2          = fread(FID, 1, 'real*8');
perturb        = fread(FID, 1, 'integer*4');
lin             = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');
status = fclose(FID);


% on affiche quelques informations sur la simulation
fprintf(1, 'Dimensions du probleme: %i * %i * %i \n', NX, NY, NZ);
fprintf(1, 'Dimensions physiques de la boite: %f * %f * %f \n', LX, LY, LZ);
if stratification
	fprintf(1, 'Stratification: %f \n\n', xns);
else
  fprintf(1, 'Stratification: non \n\n', xns);
end

FID = fopen([dirt,'/',fichier], 'r',type_endian);

% on lit toutes les metadonnees d'un coup "comme si" c'tait des entiers de 4 octets mme si ce n'est pas vrai,
% l'important est que le nombre d'octets soit respecte

poub = fread(FID, 33, 'integer*4');

poub = fread(FID, 1, 'integer*4');
instant = fread(FID, 1, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_X = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_Y = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_Z = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Rho = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_X = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_Y = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_Z = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');
VBX = fread(FID, NX*NY, 'real*8');
VBY = fread(FID, NX*NY, 'real*8');
VBZ = fread(FID, NX*NY, 'real*8');
poub = fread(FID, 2, 'integer*4');
WBX = fread(FID, NX*NY, 'real*8');
WBY = fread(FID, NX*NY, 'real*8');
WBZ = fread(FID, NX*NY, 'real*8');
status = fclose(FID);

% on imprime dans le fichier de sortie au format correspondant : little-endian si le fichier d'entre est en big-endian et
% inversement.

if strcmp(type_endian, 'ieee-le')
    type_endian_ecriture = 'ieee-be';
    fichier_ecriture = [dirt,'/',fichier,'_big_endian']
else
    type_endian_ecriture = 'ieee-le';
    fichier_ecriture = [dirt,'/',fichier,'_little_endian']
end


FID = fopen(fichier_ecriture, 'w',type_endian_ecriture);

fwrite(FID, 124, 'integer*4');
fwrite(FID, 1, 'integer*4');
fwrite(FID, NX, 'integer*4');
fwrite(FID, NY, 'integer*4');
fwrite(FID, NZ, 'integer*4');
fwrite(FID, LX, 'real*8');
fwrite(FID, LY, 'real*8');
fwrite(FID, LZ, 'real*8');
fwrite(FID, dt, 'real*8');
fwrite(FID, truncate, 'integer*4');
fwrite(FID, type_trunc, 'integer*4');
fwrite(FID, rtrunc_x, 'real*8');
fwrite(FID, rtrunc_y, 'real*8');
fwrite(FID, rtrunc_z, 'real*8');
fwrite(FID, nu, 'real*8');
fwrite(FID, stratification, 'integer*4');
fwrite(FID, xns, 'real*8');
fwrite(FID, schm, 'real*8');
fwrite(FID, omega2, 'real*8');
fwrite(FID, perturb, 'integer*4');
fwrite(FID, lin, 'integer*4');
fwrite(FID, 124, 'integer*4');

fwrite(FID, 8, 'integer*4');
fwrite(FID, instant, 'real*8');
fwrite(FID, 8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Velo_X, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Velo_Y, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Velo_Z, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Rho, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Vort_X, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Vort_Y, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*NZ*8, 'integer*4');
fwrite(FID, Vort_Z, 'real*8');
fwrite(FID, NX*NY*NZ*8, 'integer*4');

fwrite(FID, NX*NY*8*3, 'integer*4');
fwrite(FID, VBX, 'real*8');
fwrite(FID, VBY, 'real*8');
fwrite(FID, VBZ, 'real*8');
fwrite(FID, NX*NY*8*3, 'integer*4');

fwrite(FID, NX*NY*8*3, 'integer*4');
fwrite(FID, WBX, 'real*8');
fwrite(FID, WBY, 'real*8');
fwrite(FID, WBZ, 'real*8');
fwrite(FID, NX*NY*8*3, 'integer*4');

status = fclose(FID);

