% ce script permet de lire les resultats de la determination de l'energie cinetique, potentielle et de l'enstrophie
% dans chacune des couches horizontales

if strcmp('PCWIN', computer)
	ls('.');
else
	system(['ls -t ', '.']);
end

file_name = input('Energy file to use: ', 's');


% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(file_name, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(file_name, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end

% on lit toutes les metadonnees
FID = fopen(file_name, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
nb_file         = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
instants        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_h        = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_v        = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_t        = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
pot_energy      = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h     = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_v     = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_t     = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

status = fclose(FID);

energy_h  = reshape(energy_h, [nb_file,nz]);
energy_v  = reshape(energy_v, [nb_file,nz]);
energy_t  = reshape(energy_t, [nb_file,nz]);
pot_energy  = reshape(pot_energy, [nb_file,nz]);
enstrophy_h  = reshape(enstrophy_h, [nb_file,nz]);
enstrophy_v  = reshape(enstrophy_v, [nb_file,nz]);
enstrophy_t  = reshape(enstrophy_t, [nb_file,nz]);

% on cre la grille des points de colocation
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);


%figure(10)
%[C,h] = contour(instants,Z,energy_t');
%set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2)
