% ce script vise a essayer de determiner les caracteristiques du toubillons de Lamb-Oseen (rayon, vorticite)
% s'ajustant au mieux  un champ de vorticite observee.

function [vort_z_theorique] = build_vort_z_theorique2(x_p,y_p,Gamma_p,a_p,b_p,x_n,y_n,Gamma_n,a_n,b_n,lx,ly,nx,ny)

nb_adjacent = 1;
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);

c_p = sqrt(0.5*(a_p^2+b_p^2));
c_n = sqrt(0.5*(a_n^2+b_n^2));

% we determine the square distance of every vortex core to the grid points (X,Y)
distance_p = zeros(nx,ny,2*nb_adjacent+1,2*nb_adjacent+1);
distance_n = zeros(nx,ny,2*nb_adjacent+1,2*nb_adjacent+1);

for nb_boite_x = -nb_adjacent:nb_adjacent
    for nb_boite_y = -nb_adjacent:nb_adjacent
        x_tourbillon_p = x_p + nb_boite_x*lx;
        y_tourbillon_p = y_p + nb_boite_y*ly;

        x_tourbillon_n = x_n + nb_boite_x*lx;
        y_tourbillon_n = y_n + nb_boite_y*ly;

        for j=1:ny
	        distance_p(:,j,nb_boite_x+nb_adjacent+1,nb_boite_y+nb_adjacent+1) = (X - x_tourbillon_p).^2/a_p^2 + (Y(j) - y_tourbillon_p)^2/b_p^2;

	        distance_n(:,j,nb_boite_x+nb_adjacent+1,nb_boite_y+nb_adjacent+1) = (X - x_tourbillon_n).^2/a_n^2 + (Y(j) - y_tourbillon_n)^2/b_p^2;
    	end
	end
end

vort_z_theorique = zeros(nx, ny);

for nb_boite_x = 1:2*nb_adjacent+1
    for nb_boite_y = 1:2*nb_adjacent+1
          vort_z_theorique = vort_z_theorique + Gamma_p/(pi*c_p^2)*exp(-distance_p(:,:,nb_boite_x,nb_boite_y)) + Gamma_n/(pi*c_n^2)*exp(-distance_n(:,:,nb_boite_x,nb_boite_y));
    end
end

pcolor(X,Y,vort_z_theorique')
shading flat
xlabel('x')
ylabel('y')


